import {
    createDefaultModule, createDefaultSharedModule, DefaultSharedModuleContext, inject,
    LangiumServices, LangiumSharedServices, Module, PartialLangiumServices
} from 'langium';
import { BlackDogGeneratedModule, BlackDogGeneratedSharedModule } from './generated/module';
import { BlackDogValidator, registerValidationChecks } from './black-dog-validator';

/**
 * Declaration of custom services - add your own service classes here.
 */
export type BlackDogAddedServices = {
    validation: {
        BlackDogValidator: BlackDogValidator
    }
}

/**
 * Union of Langium default services and your custom services - use this as constructor parameter
 * of custom service classes.
 */
export type BlackDogServices = LangiumServices & BlackDogAddedServices

/**
 * Dependency injection module that overrides Langium default services and contributes the
 * declared custom services. The Langium defaults can be partially specified to override only
 * selected services, while the custom services must be fully specified.
 */
export const BlackDogModule: Module<BlackDogServices, PartialLangiumServices & BlackDogAddedServices> = {
    validation: {
        BlackDogValidator: () => new BlackDogValidator()
    }
};

/**
 * Create the full set of services required by Langium.
 *
 * First inject the shared services by merging two modules:
 *  - Langium default shared services
 *  - Services generated by langium-cli
 *
 * Then inject the language-specific services by merging three modules:
 *  - Langium default language-specific services
 *  - Services generated by langium-cli
 *  - Services specified in this file
 *
 * @param context Optional module context with the LSP connection
 * @returns An object wrapping the shared services and the language-specific services
 */
export function createBlackDogServices(context: DefaultSharedModuleContext): {
    shared: LangiumSharedServices,
    BlackDog: BlackDogServices
} {
    const shared = inject(
        createDefaultSharedModule(context),
        BlackDogGeneratedSharedModule
    );
    const BlackDog = inject(
        createDefaultModule({ shared }),
        BlackDogGeneratedModule,
        BlackDogModule
    );
    shared.ServiceRegistry.register(BlackDog);
    registerValidationChecks(BlackDog);
    return { shared, BlackDog };
}
